/* Copyright (c) Oracle Corporation 1999.  All Rights Reserved. */

package myclasses;

import java.util.ArrayList;

import netscape.javascript.*;

/**
** <PRE>
** <B>NAME</B>
**      modalDlg.java
**
** <B>DESCRIPTION</B>
**
** <B>NOTES</B>
**
** <B>VERSION</B>
**      $Id: modalDlg.java,v 1.2 1999/12/16 08:43:10 cjharris Exp $
** <B>MODIFIED  (MM/DD/YY)</B>
**      cjharris 12/13/99 -  Merge in HTML Forms
**      cjharris 09/16/99 - Creation
** </PRE>
*/
public class ModalDlg
{
	public  ArrayList ElemArray = new ArrayList();

    //------------------------------------------------------------------------
    // Public methods
    //------------------------------------------------------------------------
    
    public void buildBody()
	{
	    //
	    // Pass ElemArray to JavaScript and have javascript
		// build the whole modalDlg body at once
		//

		Object args[] = new Object[1];
		args[0]       = ElemArray.toArray();
/*
		for (int i=0; i < 5; i++)
		{
		    System.out.println("modalDlg.buildBody: item["+i+"] is " + args[0][i]);
		}
*/
        System.out.println("modalDlg.buildBody: Calling buildBody in Javascript");
		call ("buildBody", args);
	}


    // This populates an element definition array.  It is passed 
	// to JavaScript, where it is put in an array of element definitions
	// which are used to build the actual DOM elements in a modalDlg.
	//
    public void populate(String parentId, int i)
	{

        // Construct the strings needed to create a DOM element
	    String ElemArgs[] = new String[8];

		ElemArgs[0] = "INPUT";
		ElemArgs[1] = "type";
		ElemArgs[2] = "text";
		ElemArgs[3] = "ID";
		ElemArgs[4] = "field" + (new Integer(i)).toString();
		ElemArgs[5] = "VALUE";
		ElemArgs[6] = ElemArgs[4];
        ElemArgs[7] = parentId;

		System.out.println("populate:");
		for (int j=0; j < 8; j++)
		{
			System.out.println("    " + ElemArgs[j]);
		}

		ElemArray.add((Object) ElemArgs);
    }
    
    public void load()
	{
		System.out.println("***modalDlg.load: Start of Method");

        //
        // Create an internal array (3 elements) that each is
		// an array of 8 elements needed to create a DOM element.
		//
		for (int i = 0; i < 3; i++)
		{
            populate("form1", i);  // pass in parent id
		}

        //
		// Send the array of arrays to main window's javascript.
		// When the modalDlg is created (see javascript 'showWin'
		// function), this info will be used by modal.html to 
		// build 3 elements in its DOM.
		//
		buildBody(); 

        //
        // Send the focus to the focus element of the modalDlg.
		// unfortunately, our modalDlg is not up yet, so we need
		// to just pass it's id to JavaScript so that the modalDlg
		// can get it and use it at startup.
		//
		System.out.println("***modalDlg.load: setting the initial focus id");
		String id[] = new String[1];
		id[0] = "field1";
		call("setDialogFocus", id);

 	    System.out.println("***modalDlg.load: End of Method");
    }   

    //------------------------------------------------------------------------
    // Package Methods
    //------------------------------------------------------------------------

    ModalDlg(ModalWin appMain)
	{
	    System.out.println("***modalDlg.Constructor(): Start of method");
		mMain     = appMain;

		System.out.println("***modalDlg.Constructor():Call into Javascript to initDialog");
		call("initDialog", (Object []) null);

	    System.out.println("***modalDlg.Constructor(): End of method");
	}

    //
    // Call a JavaScript function using the DOM window.
	//
    public void call(String method, Object args[])
    {
        mMain.call(method, args);
    }

    //------------------------------------------------------------------------
    // Private Methods
    //------------------------------------------------------------------------
 
    //------------------------------------------------------------------------
    // Private Variables
    //------------------------------------------------------------------------
    private ModalWin  mMain      = null;
}